#!/usr/bin/perl
use strict;
use warnings;
use Fcntl;
use Encode;
use utf8;
use strict;
binmode(STDOUT, ":utf8");
binmode(STDIN, ":utf8");


$| = 1;

if (1)
{
	#ファイル定義
	#my $ruleFile=".\\S_rule_mecab.tsv";	#初めに用意
	my $ruleFile="$ARGV[0]";
	my $inFile=".\\S_inData_mecab.csv";	#入力データを元にVBで作成
	my $outFile=".\\S_outData.csv";		#perlで作成する→画面に表示
	my $logFile=".\\AEX_err_log.txt";		#perlで作成する→エラーログ

	#ログファイル
	open (LOG, ">$logFile") or die "$!";

	#入力ファイル読み込み
	my @IN   = split( /\n/, get_file( $inFile ) );
	my @RULE = split( /\n/, get_file( $ruleFile ) );

	#出力ファイルオープン
	open (OUT, ">$outFile") or die print (LOG "OPEN ERROR:ファイルが書き込めません。ファイル名：$outFile\n");

	#ルールを配列へ
	my @ruleAll;
	my @inDataBef = ();
	
	foreach my $lineRule ( @RULE ) {

		#ルールフォーマット→症状No,症状,ICD,カテゴリー,検No,検索,除外
		my @inData = split( /\t/, $lineRule );
		$inData[5] = get_replaceWd($inData[5]);	#検索文字列
		$inData[6] = get_replaceWd($inData[6]);	#除外文字列

		#一度、ダミーで検索しておく。
		my $dummy = "SERCH_TEST";
		eval {
			$dummy =~ /$inData[5]/g;
		};
		if($@) {
			print (LOG "FORMAT ERROR:ルールファイルを見直してください。:カテゴリー【$inData[3]】検索文字列【$inData[5]】\n");
		}

		#検索条件がなければ、ルールから外す。
		if ( $inData[5] ne '' ) {

			#症状No、症状、ICD、カテゴリーがなければ、前のデータを使用。
			for ( my $cnt = 0; $cnt < 4; $cnt++ ) {
				if ( $inData[$cnt] eq '' ) {
					$inData[$cnt] = $inDataBef[$cnt];
				}
			}
			push ( @ruleAll, \@inData );
			@inDataBef = @inData;
		} else {
			print (LOG "INFO:検索条件がありません。:カテゴリー【$inData[3]】\n");
		}
	}
	###############################################################################
	#S情報を読み込んで、検索文字列が該当するか調べる。
	
	foreach my $lineIn (@IN) {

		###########################################################################S項目は「。」で分割する。
		my $kugiri = "。";
		my @Sjyoho = split( /$kugiri/,$lineIn );
		my $gaitoCatego = '';

		###########################################################################分割した１行づつ検索処理する
		foreach my $lineS ( @Sjyoho ) {
		
			my $wkLineS = $lineS;

			#S情報に対して、ルールに対応する文言があるかどうか。
			my $ruleCntMax = @ruleAll;

			#$ruleCnt = 0 はルール項目名
			#ルールフォーマット→症状No,症状,ICD,カテゴリー,検No,検索,除外
			#######################################################################１ルールづつ検索
			for ( my $ruleCnt = 1; $ruleCnt < $ruleCntMax; $ruleCnt++ ) {

				my $syojNo = $ruleAll[$ruleCnt][0] ? $ruleAll[$ruleCnt][0] : '';
				my $syojyo = $ruleAll[$ruleCnt][1] ? $ruleAll[$ruleCnt][1] : '';
				my $icdcod = $ruleAll[$ruleCnt][2] ? $ruleAll[$ruleCnt][2] : '';
				my $catego = $ruleAll[$ruleCnt][3] ? $ruleAll[$ruleCnt][3] : '';
				my $searNo = $ruleAll[$ruleCnt][4] ? $ruleAll[$ruleCnt][4] : '';
				my $search = $ruleAll[$ruleCnt][5] ? $ruleAll[$ruleCnt][5] : '';
				my $jyogai = $ruleAll[$ruleCnt][6] ? $ruleAll[$ruleCnt][6] : '';
				
				# エラーフラグ　(0:正常　1:除外条件　2:　３単語以上)
				my $errFlg = -1;
				
				#一度、検索が成功した場合、
				#その場所から次のルールを検索してしまうので、
				#次のルールになったら、検索対象文字列を入れなおす。
				$wkLineS = $lineS;

				LOOP : while ( $wkLineS =~ /$search/g ) {
					$errFlg = 0;
					my $muchWd = $&;
					my @muchWk = ($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$20);
					
					if ( ( $jyogai ne '' ) && ( $wkLineS =~ /$jyogai/ ) ) {
						$errFlg = 1;		#	除外条件エラー
					} else {
						# 検索文字列内の「(.\?)」をさがして、
						# それが当てはまる文字列が２単語以内であるかを調べる
						my $findCnt = 0;
						
						#(の位置検索
						my $searchIdx = 0;
						SEARCH : while ( ( $searchIdx = index( $search, "\(", $searchIdx )) != -1 ) {
							#(.*?の位置検索
							if ( ( my $indKen = index( $search, "\(\.\*\?\)", $searchIdx )) != -1 ) {
								if ( $searchIdx == $indKen ) {
									my $wk = $muchWk[$findCnt] ? $muchWk[$findCnt] : '';

									# ３単語以内とは、空白が３以下
									my $muchCnt = scalar( $wk =~ s/ / /g );
										
									if ( ( $muchCnt eq '' ) || ( $muchCnt <= 3 ) ) {
										$errFlg = 0;		#該当データ
										#(の位置検索終了
										last SEARCH;
									} else {
										$errFlg = 2;		#３単語以上エラー
									}
								}
							} else {
								#(の位置検索終了
								last SEARCH;
							}
							$findCnt++;		#（の見つかった数
							$searchIdx++;	#検索開始位置
						}
					}
					last LOOP if ( $errFlg == 0 );
				}
				if ( $errFlg == 0 ) {
					# 症状No.症状(カテゴリー:ICDコード)-検索No.
					# カテゴリー:ICDコード:検索No/
					my $outForm = "$catego\:$icdcod\:$searNo";
					if ( $gaitoCatego eq '' ) {
						$gaitoCatego = $outForm;
					} else {
						$gaitoCatego = $gaitoCatego."/".$outForm;
					}
				}
			}	 
			 
		}
		#出力ファイルに出力する。
		my $lineOut = "$lineIn\t$gaitoCatego\n";
		Encode::_utf8_off($lineOut);
		decode('UTF-8', $lineOut);
		print (OUT $lineOut);
	}
	close (OUT);
	close (LOG);
	###############################################################################

}
####################################################
#                                                  #
#	指定されたファイルを読み込み、UTF-8に変換する。#
#	return　改行で区切られた文字列                 #
#                                                  #
####################################################
sub get_file
{
	my $file = $_[0];
	my $text;
	open (IN_TEMP2,$file) || die print (LOG "OPEN ERROR:ファイルが開けません。ファイル名：$file\n");
	while(my $a=<IN_TEMP2>)
	{
	chomp ($a);
	Encode::_utf8_off($a);
	$a= decode('UTF-8', $a);
	$text.=$a."\n";
	}
	close(IN_TEMP2);
	return $text;
}
####################################################
#                                                  #
#	空白を調整する。                               #
#	return　空白を調整した文字列                   #
#                                                  #
####################################################
sub get_replaceWd
{
		my $word = $_[0] ? $_[0] : return '';

		
		#「+」を「.*?」に置換

		my @replace = split( /\+/, $word );
		my $replaceLine = '';
		my $cnt = 0;
		
		# ＋　で区切られたルールの空白を調整する。
		foreach my $replaceWd ( @replace ) {
			
			# ( カッコがない場合、先頭に空白追加
			if ( $replaceWd !~ m/\(/ ) {
				# 正規表現　\s＝空白文字　\S＝非空白文字
				$replaceWd =~ s/^(\S)/ $1/g;
			}
			
			$replaceWd =~ s/\s$//g;
			
			$replaceWd =~ s/\s\|/\|/g;
			
			$replaceWd =~ s/\s\)/\)/g;
			
			$replaceWd =~ s/\s\(/\(/g;
			
			$replaceLine = $replaceLine.$replaceWd."\(\.\*\?\)";
			
		}
		$replaceLine =~ s/\(\.\*\?\)$//g;
		return $replaceLine." ";
}
1;
